#pragma once

#include "CoreMinimal.h"
#include "Components/ActorComponent.h"
#include "AnimationLayerSystemComponent.generated.h"

class UAnimationLayerDatabase;
class UAnimCollection;
class UAnimationLayerData;
class UAnimationLayerDatabaseDataList;
class UAnimationDatabaseRow;

UCLASS(Blueprintable, meta=(BlueprintSpawnableComponent))
class UAnimationLayerSystemComponent : public UActorComponent
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	UAnimationLayerDatabase* _database;

private:
	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	TMap<UAnimationLayerData*, UAnimCollection*> _layerDataAnimCollection;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, Instanced, meta=(AllowPrivateAccess=true))
	TMap<UAnimationDatabaseRow*, UAnimationLayerDatabaseDataList*> _loadedDatabaseRowToDataList;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	TMap<UAnimationDatabaseRow*, int32> _databaseRowAnimCollectionLoadedCount;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, Instanced, meta=(AllowPrivateAccess=true))
	TArray<UAnimationDatabaseRow*> _onTickLoadingRows;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, Instanced, meta=(AllowPrivateAccess=true))
	TArray<UAnimationDatabaseRow*> _onTickUnloadingRows;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, Instanced, meta=(AllowPrivateAccess=true))
	TArray<UAnimationLayerData*> _onTickLinkingLayerData;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, Instanced, meta=(AllowPrivateAccess=true))
	TArray<UAnimationLayerData*> _onTickUnLinkingLayerData;

public:
	UAnimationLayerSystemComponent();
};

FORCEINLINE uint32 GetTypeHash(const UAnimationLayerSystemComponent) { return 0; }
